//+------------------------------------------------------------------+
//|                                             Basketting_alert.mq4 |
//|                                                           Ananth |
//|                                             http://www.ananth.me |
//+------------------------------------------------------------------+
#property copyright "Ananth"
#property link      "http://www.ananth.me"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 RoyalBlue

extern bool      alertsOn        = false;
extern bool      alertsMessage   = true;
extern bool      alertsSound     = false;
extern bool      alertsEmail     = false;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_ARROW,0,0);
   SetIndexStyle(1,DRAW_ARROW,0,0);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexArrow(0,234);
   SetIndexArrow(1,233);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   for(int i=Bars-1;i>=0;i--)
   {
      double HA00=iCustom(NULL, 0, "Heiken_Ashi_Smoothed",2,15,2,15,0,i);
      double HA10=iCustom(NULL, 0, "Heiken_Ashi_Smoothed",2,15,2,15,1,i);
      double HA20=iCustom(NULL, 0, "Heiken_Ashi_Smoothed",2,15,2,15,2,i);
      double HA30=iCustom(NULL, 0, "Heiken_Ashi_Smoothed",2,15,2,15,3,i);
      double HA01=iCustom(NULL, 0, "Heiken_Ashi_Smoothed",2,15,2,15,0,i+1);
      double HA11=iCustom(NULL, 0, "Heiken_Ashi_Smoothed",2,15,2,15,1,i+1);
      double HA21=iCustom(NULL, 0, "Heiken_Ashi_Smoothed",2,15,2,15,2,i+1);
      double HA31=iCustom(NULL, 0, "Heiken_Ashi_Smoothed",2,15,2,15,3,i+1);
      double VQz20=iCustom(NULL, 0, "VQzz2",60,6,2,2,5,false,3,i);
         ExtMapBuffer1[i] = EMPTY_VALUE;
         ExtMapBuffer2[i] = EMPTY_VALUE;
            if((HA00 > HA10 && HA20 > HA30) && (HA01 < HA11 || HA21 < HA31) && VQz20 < 0 ) ExtMapBuffer1[i] = HA00+(300*Point);
            if((HA00 < HA10 && HA20 < HA30) && (HA01 > HA11 || HA21 > HA31) && VQz20 > 0 ) ExtMapBuffer2[i] = HA20-(300*Point);
   }
   manageAlerts();
   return(0);
  }
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      for (int forBar=0; forBar<Bars-1; forBar++) if (ExtMapBuffer1[forBar]!=EMPTY_VALUE || ExtMapBuffer2[forBar]!=EMPTY_VALUE) break;
      if (ExtMapBuffer1[forBar]!=EMPTY_VALUE || ExtMapBuffer2[forBar]!=EMPTY_VALUE)
      {
         if (ExtMapBuffer1[forBar]!=EMPTY_VALUE) doAlert(forBar,"down");
         if (ExtMapBuffer2[forBar]!=EMPTY_VALUE) doAlert(forBar,"up");
      }            
   }
} 
void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" basketing trend signal "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," basketing trend"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

